/* compiler.h
	P.Chongstitvatana
	19 Aug 97

	3 Apr 2001  start project RZ
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "icode.h"
#include "token.h"


#define DEBUG

#define	TABLESIZE	500
#define LOCALSIZE   100
#define NAMELEN		32
#define STRLEN      80
#define MAXCS		5000
#define MAXFUNC		500

#define	tkIDENTIFIER    10
#define	tkNUMBER        11
#define	tkSTRING        12
#define	tkEOF           13
#define tkNIL		    14
#define	tkERROR         15

#define tyVECTOR        3
#define tySCALAR        4
#define tyFUNCTION      6
#define tyLOCAL		    7

#define NL_CHAR		10
#define EOF_CHAR	255

typedef unsigned char uchar;
typedef char string[STRLEN];

typedef struct {
  char name[NAMELEN];
  int  type;
  int  ref;
  int  arg;
} sym_entry;

extern  int tok;		/* current token type, string */
extern  char tokstring[];
extern  int line;		/* current position */
extern  uchar CH;

extern  uchar CS[];
extern  int CP;

extern  int CSLINE[];
extern  int CPLINE;

/* head.c */
void writeHead(FILE *fo, int csize, int dsize);

/* stmt.c */
void seterror(char *mess);
void expect( int tktype, char *mess );
int setFunc(char *name);
int putSym(char *name, int type, int ref, int arg);
int getVec(char *name);
int doFunc(char *name);
void clean(void);
void printstr(void);
void doLval(char *name);
void doRval(char *name);
void commit( int status );
void patchIf( int a, int b, int here );

/* lex.c */
char *getsrc(int line);
void lex(void);
void initCharType(void);
int isDigit(uchar c);
int isLetterOrDigit(uchar c);
void accept(int v, int k);
void getC(void);
void unget(void);
void readinfile(char *fname);
void doline(void);

/* symtab.c */
int installLocal(char *name, int *found);
int installGlobal(char *name, int type, int ref, int arg, int *found);
int install(char *name);
void getAt(int index, int *type, int *ref, int *arg);
void setRef(int index, int ref);

/* icode.c */
void showCode(void);
void out( uchar code );
void out1( int c1 );
void out2( uchar c1, int c2 );
void out3( uchar c1, int c2, int c3 );
void patch( int ads, int v );
void dumpCode(void);
void reName(void);

